/*
 * LMDB Abstraction Layer.
 * Copyright (C) 2023  Yury Gubich <blue@macaw.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef LMDBAL_CURSOR_H
#define LMDBAL_CURSOR_H

#include "base.h"
#include "storage.h"

namespace LMDBAL {

template <class K, class V>
class Cursor {
    friend class Storage<K, V>;
private:
    Cursor(Storage<K, V>* parent);
    ~Cursor();

public:
    void open();
    void close();

private:
    void terminated();

private:
    Storage<K, V>* storage;
};

};


#include "cursor.hpp"

#endif //LMDBAL_CURSOR_H
